Liferay.Loader.define("redirect-web@1.0.43/js/ChainedRedirectionsModal", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/button', '@frontend-taglib-clay$clayui/form', '@frontend-taglib-clay$clayui/modal', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _button = _interopRequireDefault(require("@frontend-taglib-clay$clayui/button"));

    var _form = require("@frontend-taglib-clay$clayui/form");

    var _modal = _interopRequireDefault(require("@frontend-taglib-clay$clayui/modal"));

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    var noop = function noop() {};

    var ChainedRedirectionsModal = function ChainedRedirectionsModal(_ref) {
      var _ref$callback = _ref.callback,
          callback = _ref$callback === void 0 ? noop : _ref$callback,
          observer = _ref.observer,
          _ref$onModalClose = _ref.onModalClose,
          onModalClose = _ref$onModalClose === void 0 ? noop : _ref$onModalClose,
          redirectEntryChainCause = _ref.redirectEntryChainCause,
          saveButtonLabel = _ref.saveButtonLabel;

      var _useState = (0, _react.useState)(true),
          _useState2 = _slicedToArray(_useState, 2),
          updateChainedRedirectEntries = _useState2[0],
          setUpdateChainedRedirectEntries = _useState2[1];

      return (/*#__PURE__*/_react.default.createElement(_modal.default, {
          className: "portlet-redirect-modal",
          observer: observer,
          size: "md",
          status: "warning"
        }, /*#__PURE__*/_react.default.createElement(_modal.default.Header, null, Liferay.Language.get('redirect-chain')), /*#__PURE__*/_react.default.createElement("form", {
          onSubmit: function handleSubmit(event) {
            event.preventDefault();
            callback(updateChainedRedirectEntries);
          }
        }, /*#__PURE__*/_react.default.createElement(_modal.default.Body, null, /*#__PURE__*/_react.default.createElement("p", {
          className: "portlet-redirect-modal-title"
        }, /*#__PURE__*/_react.default.createElement("strong", null, redirectEntryChainCause === 'sourceURL' ? Liferay.Language.get('do-you-want-to-create-the-redirect-and-update-the-references') : Liferay.Language.get('do-you-want-to-create-this-redirect-and-update-it'))), /*#__PURE__*/_react.default.createElement("div", {
          className: "portlet-redirect-modal-description"
        }, /*#__PURE__*/_react.default.createElement("p", null, redirectEntryChainCause === 'sourceURL' ? Liferay.Language.get('there-are-other-redirects-pointing-to-the-source-url-of-this-redirect') : Liferay.Language.get('this-redirect-points-to-the-source-url-of-another-redirect')), /*#__PURE__*/_react.default.createElement("p", null, redirectEntryChainCause === 'sourceURL' ? Liferay.Language.get('update-the-references-of-the-other-redirects-to-avoid-this-chain') : Liferay.Language.get('update-this-redirect-to-avoid-this-chain'))), /*#__PURE__*/_react.default.createElement("fieldset", {
          className: "fieldset"
        }, /*#__PURE__*/_react.default.createElement(_form.ClayCheckbox, {
          checked: updateChainedRedirectEntries,
          label: redirectEntryChainCause === 'sourceURL' ? Liferay.Language.get('update-references') : Liferay.Language.get('update-redirect'),
          onChange: function onChange() {
            return setUpdateChainedRedirectEntries(function (val) {
              return !val;
            });
          }
        }))), /*#__PURE__*/_react.default.createElement(_modal.default.Footer, {
          last: /*#__PURE__*/_react.default.createElement(_button.default.Group, {
            spaced: true
          }, /*#__PURE__*/_react.default.createElement(_button.default, {
            displayType: "secondary",
            onClick: onModalClose
          }, Liferay.Language.get('cancel')), /*#__PURE__*/_react.default.createElement(_button.default, {
            displayType: "primary",
            type: "submit"
          }, saveButtonLabel))
        })))
      );
    };

    var _default = ChainedRedirectionsModal;
    exports.default = _default;
    //# sourceMappingURL=ChainedRedirectionsModal.js.map
  }
});
//# sourceMappingURL=ChainedRedirectionsModal.js.map